/*
  "CRCGenerator"
  Library supporting generation of a CRC8 checksum for a given dataset of 1...255 byte using CRC8-polynomial 0x97
  V1.1 / Copyright (C) 2020, T.Rode (DL1DUZ)

  Permission is granted to use, copy, modify, and distribute this software
  and documentation for non-commercial purposes.

  Required ressources:
   - 256 Byte EEPROM space to store lookup table
*/

#ifndef CRCGenerator_h_
#define CRCGenerator_h_

#if (ARDUINO >= 100)
#include <Arduino.h> 
#else
#include <WProgram.h> 
#endif

#include <stdint.h>
#include <EEPROM.h>

//################################################################################################################
//definitions
//################################################################################################################

class CRCGeneratorClass {

public:

  uint16_t init(const uint16_t LOOKUP_ADDRESS);
  uint8_t crcCalculation(const uint8_t ID, const uint8_t* DATA, const uint8_t SIZE);

private:

  uint16_t lookup_table_address = 0xFFFF;

};

extern CRCGeneratorClass CRC;

#endif // CRCGenerator_h_